#!/usr/bin/perl
use Test::More tests => 11;
use POWER::Epoll;
use Errno;
no warnings 'once';
require "t/init";

# empty events queue
($status, $result) = epoll_wait($epfd, 3);

$SIG{ALRM} = sub { };
$t = time();
alarm(1);
($status, $result) = epoll_wait($epfd, 3);
is(time()-$t, 1, 'waited 1 second');
ok($!{EINTR}, '+ interrupted by alarm');

$SIG{ALRM} = sub { syswrite W, $buf or die $! };
$t = time();
alarm(1);
($status, $result) = epoll_wait($epfd, 3);
is(time()-$t, 1, 'waited 1 second');
is(0+$!, 0, '+ interrupted by alarm, but no error in $!   WHY???');

$t = time();
($status, $result) = epoll_wait($epfd, 3);
is(time()-$t, 0, 'waited 0 second');
is($status, 2, '2 fd ready (status)');
is($#$result, 1, '2 fd ready (result)');
is_deeply({ map { @$_ } @$result }, {
    fileno(R)   => EPOLLIN,
    fileno(W)   => EPOLLOUT,
    }, 'R=IN, W=OUT');


