#!/usr/bin/perl
use Test::More tests => 12;
use POWER::Epoll;
use Errno;
use Data::Dumper;
use Socket;
no warnings 'once';

$epfd = epoll_create(10);

$PORT = 9750;	# just some unused port

socket(S, AF_INET, SOCK_STREAM, getprotobyname('tcp'))	or die "socket: $!";
setsockopt(S, SOL_SOCKET, SO_REUSEADDR, pack('l', 1))	or die "setsockopt: $!";
bind(S, sockaddr_in($PORT, INADDR_LOOPBACK))		or die "bind: $!";
listen(S, SOMAXCONN)					or die "listen: $!";
fcntl(S,F_SETFL,fcntl(S,F_GETFL,0)|O_NONBLOCK)		or die "fcntl: $!";

socket(C, AF_INET, SOCK_STREAM, getprotobyname('tcp'))	or die "socket: $!";
fcntl(C,F_SETFL,fcntl(C,F_GETFL,0)|O_NONBLOCK)		or die "fcntl: $!";
connect(C, sockaddr_in($PORT, INADDR_LOOPBACK));
epoll_add($epfd, fileno(C), EPOLLET|EPOLLIN);

if (not fork) {
    accept c, S						or die "accept: $!";
    syswrite c, " " x 10				or die "write: $!";
#    kill 9, $$;
    exit;
} else {
    sleep 1; # guaranty chield will die before we continue
}

($status, $result) = epoll_wait($epfd, 3);
is($status, 1, '1 fd ready (status)');
is($#$result, 0, '1 fd ready (result)');
is($result->[0][0], fileno(C), 'got C');
is($result->[0][1], EPOLLIN, 'C = IN');

$n = sysread C, $buf, 4;
is($n, 4, 'read 4 bytes');
$n = sysread C, $buf, 4;
is($n, 4, 'read 4 bytes');
$n = sysread C, $buf, 4;
is($n, 2, 'read 2 bytes');
$n = sysread C, $buf, 4;
ok((defined $n and $n == 0), 'read 0 bytes (eof)');
$n = sysread C, $buf, 4;
ok((defined $n and $n == 0), 'read 0 bytes (eof)');

($status, $result) = epoll_wait($epfd, 1);
is($status, 0, '0 fd ready (status) -- timeout');
is($#$result, -1, '0 fd ready (result) -- timeout');

$n = sysread C, $buf, 4;
ok((defined $n and $n == 0), 'read 0 bytes (eof)');

#print Dumper [$status, $result];

