#!/usr/bin/perl
use Test::More tests => 11;
use POWER::Epoll;
use Errno;
use Data::Dumper;
use Socket;
no warnings 'once';

$epfd = epoll_create(10);

$PORT = 9750;	# just some unused port

socket(S, AF_INET, SOCK_STREAM, getprotobyname('tcp'))	or die "socket: $!";
setsockopt(S, SOL_SOCKET, SO_REUSEADDR, pack('l', 1))	or die "setsockopt: $!";
bind(S, sockaddr_in($PORT, INADDR_LOOPBACK))		or die "bind: $!";
listen(S, SOMAXCONN)					or die "listen: $!";
fcntl(S,F_SETFL,fcntl(S,F_GETFL,0)|O_NONBLOCK)		or die "fcntl: $!";

socket(C, AF_INET, SOCK_STREAM, getprotobyname('tcp'))	or die "socket: $!";
fcntl(C,F_SETFL,fcntl(C,F_GETFL,0)|O_NONBLOCK)		or die "fcntl: $!";
connect(C, sockaddr_in($PORT, INADDR_LOOPBACK));
epoll_add($epfd, fileno(C), EPOLLET|EPOLLOUT);

if (not fork) {
    accept c, S						or die "accept: $!";
    sysread c, $buf, 10					or die "write: $!";
#    kill 9, $$;
    exit;
} else {
    sleep 1; # guaranty chield will die before we continue
}

($status, $result) = epoll_wait($epfd, 3);
is($status, 1, '1 fd ready (status)');
is($#$result, 0, '1 fd ready (result)');
is($result->[0][0], fileno(C), 'got C');
is($result->[0][1], EPOLLOUT, 'C = OUT');

$n = syswrite C, " " x 1000;
is($n, 1000, 'write 1000 bytes');
1 while $n = syswrite C, " " x 1000;
ok((not defined $n), 'write error (after number of writes)');
ok($!{ECONNRESET}, '$! = connection reset by peer');

($status, $result) = epoll_wait($epfd, 1);
is($status, 1, '1 fd ready (status)');
is($#$result, 0, '1 fd ready (result)');
is($result->[0][0], fileno(C), 'got C');
is($result->[0][1], EPOLLHUP, 'C = HUP');


#print Dumper [$status, $result];

